//
//  ViewController.swift
//  EncriptionSwift
//
//  Created by VCS on 06/03/19.
//  Copyright © 2019 vcs. All rights reserved.
//

import UIKit
import Foundation
import MTBBarcodeScanner
import AVFoundation

protocol BarcodeScannerViewControllerDelegate: NSObjectProtocol {
    func barcodeScannerViewController(_ controller: ViewController?, didScanBarcodeWithResult result: String?)
    func barcodeScannerViewController(_ controller: ViewController?, didFailWithErrorCode errorCode: String?)
}


class ViewController: UIViewController{
    
   // @IBOutlet var previewView: UIView!
    var scanner: MTBBarcodeScanner?
    var itesm = [String]()
   // @IBOutlet var countButton: UIButton!
    var delegate:BarcodeScannerViewControllerDelegate!
    
    var previewView:UIView!
    //var scanRect:ScannerOverlay
    //var scanner:MTBBarcodeScanner!
    
    //var isFlashOn:Bool = false
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        /*let key = "B4V2A1C@S#S$F"
        let iv = "0000000000000000"
        let s = "Vcs@1234"
        let enc = try! s.aesEncrypt1(key: key, iv: iv)
        print(enc)
        
        do{
            let dec = try enc.aesDecrypt1(key: key, iv: iv)
            print("dec:\(dec)")
            print("\(s == dec)")
            
        }catch let error {
            print("error:\(error)")
        }*/
        
        //self.countButton.setTitle("0", for: .normal)
        
        //scanner = MTBBarcodeScanner(previewView: previewView)
        
        previewView = UIView(frame: view.bounds)
        previewView.translatesAutoresizingMaskIntoConstraints = false
        view.addSubview(previewView)
        view.addConstraints(NSLayoutConstraint.constraints(withVisualFormat: "V:[previewView]", options: .alignAllBottom, metrics: nil, views: [
            "previewView": previewView
            ]))
        view.addConstraints(NSLayoutConstraint.constraints(withVisualFormat: "H:[previewView]", options: .alignAllBottom, metrics: nil, views: [
            "previewView": previewView
            ]))
        /*scanRect = ScannerOverlay(frame: view.bounds)
        scanRect.translatesAutoresizingMaskIntoConstraints = false
        scanRect.backgroundColor = UIColor.clear
        view.addSubview(scanRect)
        
        view.addConstraints(NSLayoutConstraint.constraints(withVisualFormat: "V:[scanRect]", options: .alignAllBottom, metrics: nil, views: [
            "scanRect": scanRect
            ]))
        view.addConstraints(NSLayoutConstraint.constraints(withVisualFormat: "H:[scanRect]", options: .alignAllBottom, metrics: nil, views: [
            "scanRect": scanRect
            ]))
        scanRect.startAnimating()*/
        scanner = MTBBarcodeScanner(previewView: previewView)
        navigationItem.leftBarButtonItem = UIBarButtonItem(barButtonSystemItem: .cancel, target: self, action: #selector(self.cancel))
        updateFlashButton()

        
    }
    
    override func viewDidAppear(_ animated: Bool) {
        if ((scanner?.isScanning) != nil) {
            scanner?.stopScanning()
        }
        MTBBarcodeScanner.requestCameraPermission(success: { success in
            if success {
                self.startScan()
            } else {
                self.delegate.barcodeScannerViewController(self, didFailWithErrorCode: "PERMISSION_NOT_GRANTED")
                self.dismiss(animated: false)
            }
        })
    }
    
    
    
    /*@IBAction func nextButtonclick(_ sender: Any) {
        print("next Click")
    }*/
    
    
    override func viewWillAppear(_ animated: Bool) {
        /*MTBBarcodeScanner.requestCameraPermission(success: { success in
            if success {
                do {
                    try self.scanner?.startScanning(resultBlock: { codes in
                        if let codes = codes {
                            for code in codes {
                                let stringValue = code.stringValue!
                                if(!self.itesm.contains(stringValue)){
                                    print("Found code: \(stringValue)")
                                    self.itesm.append(stringValue)
                                    
                                    self.countButton.setTitle("\(self.itesm.count)", for: .normal)
                                    
                                    // create a sound ID, in this case its the tweet sound.
                                    let systemSoundID: SystemSoundID = 1017
                                    
                                    // to play sound
                                    AudioServicesPlaySystemSound (systemSoundID)
                                }
                            }
                        }
                    })
                } catch {
                    NSLog("Unable to start scanning")
                }
            } else {
                //UIAlertController(title: "Scanning Unavailable", message: "This app does not have permission to access the camera", delegate: nil, cancelButtonTitle: nil, otherButtonTitles: "Ok").show()
                
                let myalert = UIAlertController(title: "Scanning Unavailable", message: "This app does not have permission to access the camera", preferredStyle: UIAlertControllerStyle.alert)
                
                myalert.addAction(UIAlertAction(title: "ok", style: .default) { (action:UIAlertAction!) in
                    print("Selected")
                })
                
                
                self.present(myalert, animated: true)
            }
        })*/
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
        
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        
        
        super.viewWillDisappear(animated)
        
        scanner?.stopScanning()
        super.viewWillDisappear(animated)
        if isFlashOn() {
            toggleFlash(false)
        }
    }
    
    func startScan() {
        var error: Error?
        try? scanner?.startScanning(resultBlock: { codes in
            //self.scanner?.stopScanning()
            let code: AVMetadataMachineReadableCodeObject? = codes?.first
            if code != nil {
                //self.delegate.barcodeScannerViewController(self, didScanBarcodeWithResult: code?.stringValue)
                //self.dismiss(animated: false)
                if let codes = codes {
                    for code in codes {
                        let stringValue = code.stringValue!
                        if(!self.itesm.contains(stringValue)){
                            print("Found code: \(stringValue)")
                            self.itesm.append(stringValue)
                            
                            //self.countButton.setTitle("\(self.itesm.count)", for: .normal)
                            
                            // create a sound ID, in this case its the tweet sound.
                            let systemSoundID: SystemSoundID = 1017
                            
                            // to play sound
                            AudioServicesPlaySystemSound (systemSoundID)
                            
                            self.delegate.barcodeScannerViewController(self, didScanBarcodeWithResult: stringValue)
                        }
                    }
                }
            }
        })
    }
    
    @objc func cancel() {
        dismiss(animated: true)
    }
    
    func updateFlashButton() {
        if !hasTorch {
            return
        }
        if isFlashOn() {
            navigationItem.rightBarButtonItem = UIBarButtonItem(title: "Flash Off", style: .plain, target: self, action: #selector(self.toggle))
        } else {
            navigationItem.rightBarButtonItem = UIBarButtonItem(title: "Flash On", style: .plain, target: self, action: #selector(self.toggle))
        }
    }
    
    @objc func toggle() {
        toggleFlash(!isFlashOn())
        updateFlashButton()
    }
    
    func isFlashOn() -> Bool {
        /*let device = AVCaptureDevice.default(for: .video)
        if device != nil {
            return device?.torchMode = AVCaptureDevice.FlashMode.on || device?.torchMode == .on
        }
        return false*/
        
       /* if self.videoDeviceInput.device.isFlashAvailable {
            
            if self.flashPhotoMode == .on {
                //photoSettings.flashMode = .on
                print("FLASH ON ")
                return true
            } else {
                print("FLASH OFF ")
                //photoSettings.flashMode = .off
                return false
            }
            
        }*/
        return false
    
    }
    
    var hasTorch: Bool {
        let device = AVCaptureDevice.default(for: .video)
        if device != nil {
            return device?.hasTorch ?? false
        }
        return false
    }
    
    func toggleFlash(_ on: Bool) {
        let device = AVCaptureDevice.default(for: .video)
        if device == nil {
            return
        }
        
        var err: Error?
        if device?.hasFlash ?? false && device?.hasTorch ?? false {
            try? device?.lockForConfiguration()
            if err != nil {
                return
            }
            if on {
                device?.flashMode = .on
                device?.torchMode = .on
            } else {
                device?.flashMode = .off
                device?.torchMode = .off
            }
            device?.unlockForConfiguration()
        }
    }
    
}

/*extension String {
    func aesEncrypt(key: String, iv: String) throws -> String{
        //let data = self.dataUsingEncoding(NSUTF8StringEncoding)
        let data1 = self.data(using: .utf8)
        let enc = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).encrypt(data1!.bytes)
        let encData = NSData(bytes: enc, length: Int(enc.count))
        let base64String: String = encData.base64EncodedString(options: NSData.Base64EncodingOptions(rawValue: 0));
        let result = String(base64String)
        return result
    }
    
    func aesDecrypt(key: String, iv: String) throws -> String {
        //let data1 = NSData(base64Encoded: self, options: NSData.Base64DecodingOptions(rawValue: 0))
        let data1 = Data(base64Encoded: self)!
        let dec = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).decrypt(Array(data1))
        let decData = NSData(bytes: dec, length: Int(dec.count))
        let result = NSString(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
        //let result = String(bytes: Data(decData).bytes, encoding: .utf8)
        print(decData)
        //let result =  String(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
        return String(result!)
    }
    
    func aesEncrypt1(key: String, iv: String) throws -> String {
        
        
        let pwdBytes = [UInt8](key.utf8)
        var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
        var len = pwdBytes.count
        if(len > keyBytes.count){
            len = keyBytes.count
            //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
        }
        
        var i:Int = 0
        while(i < len){
            keyBytes[i] = pwdBytes[i]
            i = i + 1
        }
        
        let key1 = keyBytes
        let iv1 = keyBytes
        
        let encrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).encrypt([UInt8](self.data(using: .utf8)!))
        return Data(encrypted).base64EncodedString()
    }
    
    func aesDecrypt1(key: String, iv: String) throws -> String {
        
        let pwdBytes = [UInt8](key.utf8)
        var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
        var len = pwdBytes.count
        if(len > keyBytes.count){
            len = keyBytes.count
            //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
        }
        
        var i:Int = 0
        while(i < len){
            keyBytes[i] = pwdBytes[i]
            i = i + 1
        }
        
        let key1 = keyBytes
        let iv1 = keyBytes
        
        guard let data = Data(base64Encoded: self) else { return "" }
        let decrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).decrypt([UInt8](data))
        return String(bytes: Data(decrypted).bytes, encoding: .utf8) ?? "Could not decrypt"
    }
}*/

